---

stages:
  - linting
  - test

.semrel-linter-scripts: &semrel-linter-scripts |
  # semrellint function
  function semrellint(){
    c=$1
    regex='^(Draft: )?(chore|build|ci|docs|feat|fix|perf|refactor|test)'`
          `'(\(.*\))?: ([^"].+)$'
    if [[ $c =~ $regex ]]
    then
      echo "👍 '$c' is correct:"
      if [[ ${BASH_REMATCH[1]} != "" ]];then
        echo "    this commit is a draft"
      fi
      echo "    commit type:     ${BASH_REMATCH[2]}"
      echo "    commit scope:    ${BASH_REMATCH[3]}"
      echo "    commit summary:  ${BASH_REMATCH[4]}"
    else
      echo "👎 '$c' doesn't match semrel rules" >&2
      exit 1
    fi
  }

semrel-linter:
  stage: lint
  variables:
    MSG: $CI_MERGE_REQUEST_TITLE
  image: bash
  script:
    - *semrel-linter-scripts
    - semrellint "$MSG"
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
